<?php

namespace Drupal\entity_bundle_scaffold;

use Drupal\Core\Cache\CacheBackendInterface;
use Drupal\Core\Extension\ModuleHandlerInterface;
use Drupal\Core\Plugin\DefaultPluginManager;
use Drupal\entity_bundle_scaffold\Annotation\EntityBundleClassMethodGenerator;

class EntityBundleClassMethodGeneratorManager extends DefaultPluginManager
{
    public function __construct(
        \Traversable $namespaces,
        CacheBackendInterface $cacheBackend,
        ModuleHandlerInterface $moduleHandler
    ) {
        parent::__construct(
            'Plugin/EntityBundleClassMethodGenerator',
            $namespaces,
            $moduleHandler,
            EntityBundleClassMethodGeneratorInterface::class,
            EntityBundleClassMethodGenerator::class
        );
        $this->alterInfo('entity_bundle_class_method_generator');
        $this->setCacheBackend($cacheBackend, 'entity_bundle_class_method_generator_plugins');
    }
}
